#define KEY_PORT        PORTD
#define KEY_DIR         DDRD
#define KEY_PIN         PIND
#define KEY0            (1 << PB5)
#define KEY1            (1 << PB6)
#define KEY2            (1 << PB7)

#define ALL_KEYS        (KEY0 | KEY1 | KEY2)
#define REPEAT_MASK     (KEY0 | KEY1)       // repeat: key0, key1
#define REPEAT_START    160                 // after ??ms
#define REPEAT_NEXT     20                  // every ??ms

volatile unsigned char key_state;           // debounced key state:
                                            // bit = 1: key pressed
volatile unsigned char key_press;           // key press detect
volatile unsigned char key_rpt;             // key long press and repeat

void key_init(void);
uint8_t get_key_press( uint8_t );
uint8_t get_key_rpt( uint8_t );
void process_keys( void );
