/*************************************************************************
Title:	lcd_time
Author:   
File:	 
Software: 
Hardware: 
**************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include "lcd.h"
#include "main.h"
#include "key.h"
#include "lamp.h"
#include "time.h"


unsigned int ee_time[ 256 ] EEMEM;
unsigned char		last_eepos=0;

/*
** constant definitions
*/
static const PROGMEM unsigned char copyRightChar[] =
{
	0x07, 0x08, 0x13, 0x14, 0x14, 0x13, 0x08, 0x07,
	0x00, 0x10, 0x08, 0x08, 0x08, 0x08, 0x10, 0x00
};


/*
** function prototypes
*/ 

void init(void)
{

    count_down = 0;
    last_eepos = 0;                                                              // Indexcounter 0 - 255 (unsigned char)

    while( eeprom_read_word( &ee_time[ last_eepos ] ) & 0x8000 )                 // letzten gespeicherten Wert suchen
    {
        if( ++last_eepos == 0 )
        {
            last_eepos = 255;
            break;                                                      // gesamtes EEprom nicht initialisiert
        }
    }

    preset_time = eeprom_read_word( &ee_time[ last_eepos ] );                    // gefundenen Wert holen

    if( preset_time > 5999 )                                            // falls nur Mll im EEprom steht...
    {
        preset_time = 0;
        eesave_cnt = 1;
    }

    time = preset_time;
}

void lcd_p_set(void)
{
	lcd_gotoxy(0,1);
	lcd_puts_P( "Set  :" );
}


void lcd_int(uint16_t z)// Routine zum ausgeben von Zahlen
{ 
	char buffer[7];
	unsigned char i,j;

	buffer[6]= 0;
	buffer[5]= (z % 10)+48; z = z/10;
	buffer[4]= (z % 10)+48; z = z/10;
	buffer[3]= (z % 10)+48; z = z/10;
	buffer[2]= (z % 10)+48; z = z/10;
	buffer[1]= (z % 10)+48; z = z/10;
	buffer[0]= (z)+48;
	i=2; j=0;
	while (buffer[i]!=0)
	{
		if(buffer[i]!='0') 
		{
			j=1;
		}

		if(j==1 || i==5) 
		{
			lcd_putc(buffer[i]);
		}
		else
		{
			lcd_putc(' ');
		}

		i++;
	}
}


int main(void)
{
    unsigned char acceleration = 0;
    unsigned int last_time = 0;

    unsigned int    last_preset_time = preset_time;

//	char buffer[7];
	
    last_time = 6000;			// unmglicher Wert...
	
	lamp_init();
	key_init();
	timer_init();

	init();

	/* initialize display, cursor off */
	lcd_init(LCD_DISP_ON);
	lcd_clrscr();
	lcd_puts_P( "Belichtungstimer\n" );
	lcd_puts_P( "Count:" );
    sei();


    while( 1 )                                                          // Endlosschleife
    {
        if( !count_down && (!lamp_is()) )							// Verriegelung
        {
        	if( !( key_state & KEY2 ) )                                 // ist KEY2 frei
        	{

                if( !( key_state & KEY1 ) )                             // ist entweder KEY1 frei (else!)
                {
                    if( get_key_press( KEY0 ) )                         // Time+
                    {
                        if( ( time + 1 ) < 6000 ) time++;

						lcd_p_set();
                        preset_time = time;
                    }

                    if( get_key_rpt( KEY0 ) )                           // Time++
                    {
                        if( acceleration >= 60 )
                        {
                            if( ( time + 600 ) < 6000 ) time += 600;

                            else if( ( time + 60 ) < 6000 ) time += 60;

                            else if( ( time + 10 ) < 6000 ) time += 10;

                            else if( ( time + 1 ) < 6000 ) time++;
                        }

                        else if( acceleration >= 40 )
                        {
                            if( ( time + 60 ) < 6000 ) time += 60;

                            else if( ( time + 10 ) < 6000 ) time += 10;

                            else if( ( time + 1 ) < 6000 ) time++;
                        }

                        else if( acceleration >= 19 )
                        {
                            if( ( time + 10 ) < 6000 ) time += 10;

                            else if( ( time + 1 ) < 6000 ) time++;
                        }

                        else
                        {
                            if( ( time + 1 ) < 6000) time++;
                        }
    
						lcd_p_set();

                        if( acceleration < 255 ) acceleration++;

                        preset_time = time;
                    }
                }

                else if( !( key_state & KEY0 ) )                        // oder ist KEY0 frei
                {
                    if( get_key_press( KEY1 ) )                         // Time-
                    {
                        if( time ) time--;

						lcd_p_set();
                        preset_time = time;
                    }
    
                    if( get_key_rpt( KEY1 ) )                           // Time--
                    {
                        if( acceleration >= 60 )
                        {
                            if( time >= 600 ) time -= 600;

                            else if( time >= 60 ) time -= 60;

                            else if( time >= 10 ) time -= 10;

                            else if( time ) time --;
                        }

                        else if( acceleration >= 40 )
                        {
                            if( time >= 60 ) time -= 60;

                            else if( time >= 10 ) time -= 10;

                            else if( time ) time --;
                        }

                        else if( acceleration >= 19 )
                        {
                            if( time >= 10 ) time -= 10;

                            else if( time ) time --;
                        }

                        else
                        {
                            if( time ) time--;
                        }
    
						lcd_p_set();
    
                        if( acceleration < 255 ) acceleration++;

                        preset_time = time;
                    }
                }

                else acceleration = 0;                                  // KEY0 && KEY1 waren nicht frei
            }
        }                                                               // end: if( !count_down && ( IO_PORT & LED_1 ) )

        if( !( key_state & ( KEY0 | KEY1 ) ) )
        {
            acceleration = 0;                                           // ist weder KEY0 noch KEY1 gedrckt...

            if( get_key_press( KEY2 ) )                                 // Start --- Stop
            {
                key_rpt = 0;

                if( count_down ) count_down = 0;                        // luft der Countdown, anhalten

                else                                                    // luft der Countdown nicht
                {
                    if( time )                                          // time < 0 ?
                    {
                        compare = prescaler;                            // diesen Augenblick merken...
                        time--;                                         // einmal herunterzhlen (Start Countdown)
                        count_down = 1;                                 // Countdown ein
						lamp_on();
                    }

                    else
                    {
                        if(!lamp_is()) time = preset_time;      // time == 0, lade voreingestellten Wert
                    }
                }                                                       // end: else "luft der Countdown nicht"
            }                                                           // end: if( get_key_press( KEY2 ) )
        }                                                               // end: if( !( key_state & ( KEY0 | KEY1 ) ) )


        if( last_time != time )                                         // hat sich an time was verndert?
        {                                                               // Umrechnung in 4 einzelne Variablen
			if(count_down)
			{
				lcd_gotoxy(0,1);
				lcd_puts_P( "Count:" );
			}
			lcd_gotoxy(7,1);  

			/* convert interger into string */
			lcd_int(time);
			lcd_puts_P( " sec" );
            last_time = time;                                           // nderung bernommen
        }

        if( last_preset_time != preset_time )                           // hat sich die voreingestellte Zeit gendert?
        {
            eesave_cnt = 90;                                            // ca. 90 Sekunden warten...
            last_preset_time = preset_time;                             // nderung bernommen
        }

        if( eesave_cnt == 1 )                                           // Variable wurde (im Timer-Interrupt) sekndlich herruntergezhlt
        {                                                               // bis sie den Wert 1 enthielt
			lcd_gotoxy(0,1);  
			lcd_puts_P( "Store:" );
            if( eeprom_read_word( &ee_time[ last_eepos ] ) != preset_time )      // EEprom-Schreiben bei Datengleichheit verhindern
            {                                                           // alte Speicherstelle markieren
                eeprom_write_word( &ee_time[ last_eepos ], ( eeprom_read_word( &ee_time[ last_eepos ] ) | 0x8000 ) );

                eeprom_write_word( &ee_time[ ++last_eepos ], preset_time );      // Voreinstellung speichern
            }

            eesave_cnt = 0;
        }
    }                                                                   // end while( 1 )

}


